--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new ()
on new (me)
  me._class = #Application
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  me._id = $.Qt._qx.newObject(me._class)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #Application
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- objectName () -> string
on objectName (me)
  return $.Qt._qx.callObject(me._id,#objectName)
end

-- setObjectName (string)
on setObjectName (me,p1)
  $.Qt._qx.callObject(me._id,#setObjectName,p1)
end

-- setStyleSheet (string)
on setStyleSheet (me,p1)
  $.Qt._qx.callObject(me._id,#setStyleSheet,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

-- aboutQt ()
on aboutQt (scr)
  $.Qt._qx.callObject(#Application,#aboutQt)
end

-- addLibraryPath (string)
on addLibraryPath (scr,p1)
  $.Qt._qx.callObject(#Application,#addLibraryPath,p1)
end

-- allWidgets () -> WidgetIDs
on allWidgets (scr)
  return $.Qt._qx.callObject(#Application,#allWidgets)
end

-- applicationDirPath () -> string
on applicationDirPath (scr)
  return $.Qt._qx.callObject(#Application,#applicationDirPath)
end

-- arguments () -> list
on arguments (scr)
  return $.Qt._qx.callObject(#Application,#arguments)
end

-- closeAllWindows ()
on closeAllWindows (scr)
  $.Qt._qx.callObject(#Application,#closeAllWindows)
end

-- focusWidget () -> WidgetID
on focusWidget (scr)
  obj = $.Qt.Widget._make($.Qt._qx.callObject(#Application,#focusWidget))
  return obj
end

-- getClipboard () -> ClipboardID
on getClipboard (scr)
  obj = $.Qt.Clipboard._make($.Qt._qx.callObject(#Application,#getClipboard))
  return obj
end

-- getCursorPos () -> Point
on getCursorPos (scr)
  obj = $.Qt._qx.callObject(#Application,#getCursorPos)
  return obj
end

-- getFont () -> FontID
on getFont (scr)
  obj = $.Qt.Font._make($.Qt._qx.callObject(#Application,#getFont))
  return obj
end

-- getPalette () -> PaletteID
on getPalette (scr)
  obj = $.Qt.Palette._make($.Qt._qx.callObject(#Application,#getPalette))
  return obj
end

-- keyboardModifiers () -> int
on keyboardModifiers (scr)
  return $.Qt._qx.callObject(#Application,#keyboardModifiers)
end

-- libraryPaths () -> list
on libraryPaths (scr)
  return $.Qt._qx.callObject(#Application,#libraryPaths)
end

-- mouseButtons () -> int
on mouseButtons (scr)
  return $.Qt._qx.callObject(#Application,#mouseButtons)
end

-- setAttribute (int,bool)
on setAttribute (scr,p1,p2)
  $.Qt._qx.callObject(#Application,#setAttribute,p1,p2)
end

-- setCursorFlashTime (int)
on setCursorFlashTime (scr,p1)
  $.Qt._qx.callObject(#Application,#setCursorFlashTime,p1)
end

-- setDoubleClickInterval (int)
on setDoubleClickInterval (scr,p1)
  $.Qt._qx.callObject(#Application,#setDoubleClickInterval,p1)
end

-- setFont (FontID|string)+(string,int|float,*int,bool)
on setFont (scr,p1)
  $.Qt._qx.callObject(#Application,#setFont,p1)
end

-- setKeyboardInputInterval (int)
on setKeyboardInputInterval (scr,p1)
  $.Qt._qx.callObject(#Application,#setKeyboardInputInterval,p1)
end

-- setPalette (PaletteID)
on setPalette (scr,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callObject(#Application,#setPalette,p1)
end

-- setQuitOnLastWindowClosed (bool)
on setQuitOnLastWindowClosed (scr,p1)
  $.Qt._qx.callObject(#Application,#setQuitOnLastWindowClosed,p1)
end

-- setStyle (symbol)
on setStyle (scr,p1)
  $.Qt._qx.callObject(#Application,#setStyle,p1)
end

-- setWheelScrollLines (int)
on setWheelScrollLines (scr,p1)
  $.Qt._qx.callObject(#Application,#setWheelScrollLines,p1)
end

-- testAttribute (int) -> bool
on testAttribute (scr,p1)
  return $.Qt._qx.callObject(#Application,#testAttribute,p1)
end

-- widgetAt (int,int) -> WidgetID
on widgetAt (scr,p1,p2)
  obj = $.Qt.Widget._make($.Qt._qx.callObject(#Application,#widgetAt,p1,p2))
  return obj
end

----------------------------------------
-- SIGNALS
----------------------------------------

-- focusChanged
on focusChanged(me,id)
  me._detach(#focusChanged,me)
end
