--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #WebPage
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newObject(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #WebPage
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- canGoBack() -> bool
on canGoBack (me)
  return $.Qt._qx.callObject(me._id,#canGoBack)
end

-- canGoForward() -> bool
on canGoForward (me)
  return $.Qt._qx.callObject(me._id,#canGoForward)
end

-- mainFrame () -> WebFrameID
on mainFrame (me)
  obj = $.Qt.WebFrame._make($.Qt._qx.callObject(me._id,#mainFrame))
  me._children.add(obj)
  return obj
end

-- getNetworkAccessManager () -> NetworkAccessManagerID
on getNetworkAccessManager (me)
  obj = $.Qt.NetworkAccessManager._make($.Qt._qx.callObject(me._id,#getNetworkAccessManager))
  me._children.add(obj)
  return obj
end

-- objectName () -> string
on objectName (me)
  return $.Qt._qx.callObject(me._id,#objectName)
end

-- setAllowNewWindows (bool)
on setAllowNewWindows (me,p1)
  $.Qt._qx.callObject(me._id,#setAllowNewWindows,p1)
end

-- setForwardUnsupportedContent (bool)
on setForwardUnsupportedContent (me,p1)
  $.Qt._qx.callObject(me._id,#setForwardUnsupportedContent,p1)
end

-- setLinkDelegationPolicy (int)
on setLinkDelegationPolicy (me,p1)
  $.Qt._qx.callObject(me._id,#setLinkDelegationPolicy,p1)
end

-- setObjectName (string)
on setObjectName (me,p1)
  $.Qt._qx.callObject(me._id,#setObjectName,p1)
end

-- setNetworkAccessManager (NetworkAccessManagerID)
on setNetworkAccessManager (me,p1)
	if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callObject(me._id,#setNetworkAccessManager,p1)
end

-- setSetting (int,bool)
on setSetting (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setSetting,p1,p2)
end

-- setUserAgentForUrl (propList)
on setUserAgentForUrl (me,p1)
  $.Qt._qx.callObject(me._id,#setUserAgentForUrl,p1)
end

-- setViewportSize (int w, int h)
on setViewportSize (me,p1,p2)
  $.Qt._qx.callObject(me._id,#setViewportSize,p1,p2)
end

-- triggerAction (int)
on triggerAction (me,p1)
  $.Qt._qx.callObject(me._id,#triggerAction,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- jsConsoleMessage -> string
on jsConsoleMessage(me,id,p1)
  me._detach(#jsConsoleMessage,me,p1)
end

-- windowCreated -> WebViewID
on windowCreated(me,id,p1)
  obj = $.Qt.WebView._make(p1)
  me._children.add(obj)
  me._detach(#windowCreated,me,obj)
end

-- downloadRequested -> string
on downloadRequested(me,id,p1,p2)
  me._detach(#downloadRequested,me,p1,p2)
end

-- unsupportedContent 
on unsupportedContent(me,id)
  me._detach(#unsupportedContent,me)
end
