--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #CheckBox
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #CheckBox
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- isChecked () -> bool
on isChecked (me)
  return $.Qt._qx.callWidget(me._id,#isChecked)
end

-- setChecked (bool)
on setChecked (me,p1)
  $.Qt._qx.callWidget(me._id,#setChecked,p1)
end

-- setIcon (string|image)
on setIcon (me,p1)
  $.Qt._qx.callWidget(me._id,#setIcon,p1)
end

-- setIconSize (int,int)
on setIconSize (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setIconSize,p1,p2)
end

-- setText (string)
on setText (me,p1)
  $.Qt._qx.callWidget(me._id,#setText,p1)
end

-- text () -> string
on text (me)
  return $.Qt._qx.callWidget(me._id,#text)
end

-- toggle ()
on toggle (me)
  $.Qt._qx.callWidget(me._id,#toggle)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- clicked -> bool
on clicked(me,id,p1)
  me._detach(#clicked,me,p1)
end

-- pressed
on pressed(me,id)
  me._detach(#pressed,me)
end

-- released
on released(me,id)
  me._detach(#released,me)
end

-- stateChanged -> int
on stateChanged(me,id,p1)
  me._detach(#stateChanged,me,p1)
end

-- toggled -> bool
on toggled(me,id,p1)
  me._detach(#toggled,me,p1)
end
