--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #PlainTextEdit
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #PlainTextEdit
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- appendPlainText (string)
on appendPlainText (me,p1)
  $.Qt._qx.callWidget(me._id,#appendPlainText,p1)
end

-- blockCount () -> int
on blockCount (me)
  return $.Qt._qx.callWidget(me._id,#blockCount)
end

-- clear ()
on clear (me)
  $.Qt._qx.callWidget(me._id,#clear)
end

-- copy ()
on copy (me)
  $.Qt._qx.callWidget(me._id,#copy)
end

-- cut ()
on cut (me)
  $.Qt._qx.callWidget(me._id,#cut)
end

-- findText (string,*int) -> bool
on findText (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#findText,p1,p2)
end

-- insertPlainText (string)
on insertPlainText (me,p1)
  $.Qt._qx.callWidget(me._id,#insertPlainText,p1)
end

-- paste ()
on paste (me)
  $.Qt._qx.callWidget(me._id,#paste)
end

-- print (int)
on print (me,p1)
  $.Qt._qx.callWidget(me._id,#print,p1)
end

-- redo ()
on redo (me)
  $.Qt._qx.callWidget(me._id,#redo)
end

-- selectAll ()
on selectAll (me)
  $.Qt._qx.callWidget(me._id,#selectAll)
end

-- setPlainText (string)
on setPlainText (me,p1)
  $.Qt._qx.callWidget(me._id,#setPlainText,p1)
end

-- setViewportMargins (int,int,int,int)
on setViewportMargins (me,p1,p2,p3,p4)
  $.Qt._qx.callWidget(me._id,#setViewportMargins,p1,p2,p3,p4)
end

-- toPlainText () -> string
on toPlainText (me)
  return $.Qt._qx.callWidget(me._id,#toPlainText)
end

-- undo ()
on undo (me)
  $.Qt._qx.callWidget(me._id,#undo)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- blockCountChanged -> int
on blockCountChanged(me,id,p1)
  me._detach(#blockCountChanged,me,p1)
end

-- copyAvailable -> bool
on copyAvailable(me,id,p1)
  me._detach(#copyAvailable,me,p1)
end

-- cursorPositionChanged
on cursorPositionChanged(me,id)
  me._detach(#cursorPositionChanged,me)
end

-- redoAvailable -> bool
on redoAvailable(me,id,p1)
  me._detach(#redoAvailable,me,p1)
end

-- selectionChanged
on selectionChanged(me,id)
  me._detach(#selectionChanged,me)
end

-- textChanged
on textChanged(me,id)
  me._detach(#textChanged,me)
end

-- undoAvailable -> bool
on undoAvailable(me,id,p1)
  me._detach(#undoAvailable,me,p1)
end
