--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #Scintilla
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #Scintilla
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- apiClear ()
on apiClear (me)
  $.Qt._qx.callWidget(me._id,#apiClear)
end

-- apiLoadPrepared (string preparedApiFile) -> bool
on apiLoadPrepared (me,p1)
  return $.Qt._qx.callWidget(me._id,#apiLoadPrepared,p1)
end

-- apiLoadRaw (string rawApiFile) -> bool
on apiLoadRaw (me,p1)
  return $.Qt._qx.callWidget(me._id,#apiLoadRaw,p1)
end

-- apiPrepare ()
on apiPrepare (me)
  $.Qt._qx.callWidget(me._id,#apiPrepare)
end

-- apiSavePrepared (string preparedApiFile) -> bool
on apiSavePrepared (me,p1)
  return $.Qt._qx.callWidget(me._id,#apiSavePrepared,p1)
end

-- append (string)
on append (me,p1)
  $.Qt._qx.callWidget(me._id,#append,p1)
end

-- autoCompleteFromAll ()
on autoCompleteFromAll (me)
  $.Qt._qx.callWidget(me._id,#autoCompleteFromAll)
end

-- autoCompleteFromAPIs ()
on autoCompleteFromAPIs (me)
  $.Qt._qx.callWidget(me._id,#autoCompleteFromAPIs)
end

-- autoCompleteDocument ()
on autoCompleteDocument (me)
  $.Qt._qx.callWidget(me._id,#autoCompleteDocument)
end

-- callTip ()
on callTip (me)
  $.Qt._qx.callWidget(me._id,#callTip)
end

-- clear ()
on clear (me)
  $.Qt._qx.callWidget(me._id,#clear)
end

-- convertEols (int mode)
on convertEols (me,p1)
  $.Qt._qx.callWidget(me._id,#convertEols,p1)
end

-- copy ()
on copy (me)
  $.Qt._qx.callWidget(me._id,#copy)
end

-- cut ()
on cut (me)
  $.Qt._qx.callWidget(me._id,#cut)
end

-- ensureCursorVisible ()
on ensureCursorVisible (me)
  $.Qt._qx.callWidget(me._id,#ensureCursorVisible)
end

-- ensureLineVisible (int line)
on ensureLineVisible (me,p1)
  $.Qt._qx.callWidget(me._id,#ensureLineVisible,p1)
end

-- eolMode () -> int
on eolMode (me)
  return $.Qt._qx.callWidget(me._id,#eolMode)
end

-- findFirst (string str, bool re, bool cs, bool wo, bool wrap, *bool forward) -> bool
on findFirst (me,p1,p2,p3,p4,p5,p6)
	if voidP(p6) then p6=TRUE
  return $.Qt._qx.callWidget(me._id,#findFirst,p1,p2,p3,p4,p5,p6)
end

-- findNext () -> bool
on findNext (me)
  return $.Qt._qx.callWidget(me._id,#findNext)
end

-- getCursorPosition () -> list
on getCursorPosition (me)
  return $.Qt._qx.callWidget(me._id,#getCursorPosition)
end

-- getSelection () -> list
on getSelection (me)
  return $.Qt._qx.callWidget(me._id,#getSelection)
end

-- indentationsUseTabs () -> bool
on indentationsUseTabs (me)
  return $.Qt._qx.callWidget(me._id,#indentationsUseTabs)
end

-- insert (string text)
on insert (me,p1)
  $.Qt._qx.callWidget(me._id,#insert,p1)
end

-- isModified () -> bool
on isModified (me)
  return $.Qt._qx.callWidget(me._id,#isModified)
end

-- isUtf8 () -> bool
on isUtf8 (me)
  return $.Qt._qx.callWidget(me._id,#isUtf8)
end

-- lineIndexFromPosition (int position)	-> int line
on lineIndexFromPosition (me,p1)
  return $.Qt._qx.callWidget(me._id,#lineIndexFromPosition,p1)
end

-- lineLength (int line) -> int
on lineLength (me,p1)
  return $.Qt._qx.callWidget(me._id,#lineLength,p1)
end

-- lines() -> int
on lines (me)
  return $.Qt._qx.callWidget(me._id,#lines)
end

-- paste ()
on paste (me)
  $.Qt._qx.callWidget(me._id,#paste)
end

-- positionFromLineIndex (int line, int index) -> int pos)
on positionFromLineIndex (me,p1,p2)
  return $.Qt._qx.callWidget(me._id,#positionFromLineIndex,p1,p2)
end

-- print (PrinterID)
on print (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#print,p1)
end

-- redo ()
on redo (me)
  $.Qt._qx.callWidget(me._id,#redo)
end

-- removeSelectedText ()
on removeSelectedText (me)
  $.Qt._qx.callWidget(me._id,#removeSelectedText)
end

-- replace (string)
on replace (me,p1)
  $.Qt._qx.callWidget(me._id,#replace,p1)
end

-- replaceSelectedText (string)
on replaceSelectedText (me,p1)
  $.Qt._qx.callWidget(me._id,#replaceSelectedText,p1)
end

-- selectedText () -> string
on selectedText (me)
  return $.Qt._qx.callWidget(me._id,#selectedText)
end

-- sendScintilla (int,*int,int,any) -> int
on sendScintilla (me,p1,p2,p3,p4)
	if the paramcount>4 then
  	return $.Qt._qx.callWidget(me._id,#sendScintilla,p1,p2,p3,p4)
	else if the paramcount>3 then
  	return $.Qt._qx.callWidget(me._id,#sendScintilla,p1,p2,p3)
  else if the paramcount>2 then
  	return $.Qt._qx.callWidget(me._id,#sendScintilla,p1,p2)
  else
  	return $.Qt._qx.callWidget(me._id,#sendScintilla,p1)
  end if
end

-- setAutoIndent (bool)
on setAutoIndent (me,p1)
  $.Qt._qx.callWidget(me._id,#setAutoIndent,p1)
end

-- setBraceMatching (int)
on setBraceMatching (me,p1)
  $.Qt._qx.callWidget(me._id,#setBraceMatching,p1)
end

-- setCaretForegroundColor (color)
on setCaretForegroundColor (me,p1)
  $.Qt._qx.callWidget(me._id,#setCaretForegroundColor,p1)
end

-- setCaretLineBackgroundColor (color)
on setCaretLineBackgroundColor (me,p1)
  $.Qt._qx.callWidget(me._id,#setCaretLineBackgroundColor,p1)
end

-- setCaretLineVisible (bool)
on setCaretLineVisible (me,p1)
  $.Qt._qx.callWidget(me._id,#setCaretLineVisible,p1)
end

-- setColor (color)
on setColor (me,p1)
  $.Qt._qx.callWidget(me._id,#setColor,p1)
end

--setCursorPosition (int line, int index)
on setCursorPosition (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setCursorPosition,p1,p2)
end

-- setEolMode (int mode)
on setEolMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setEolMode,p1)
end

-- setFolding (int)
on setFolding (me,p1)
  $.Qt._qx.callWidget(me._id,#setFolding,p1)
end

-- setFont (FontID)
on setFont (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setFont,p1)
end

-- setIndentationGuides (bool)
on setIndentationGuides (me,p1)
  $.Qt._qx.callWidget(me._id,#setIndentationGuides,p1)
end
 	
-- setIndentationsUseTabs (bool)
on setIndentationsUseTabs (me,p1)
  $.Qt._qx.callWidget(me._id,#setIndentationsUseTabs,p1)
end

-- setIndentationWidth (int width)
on setIndentationWidth (me,p1)
  $.Qt._qx.callWidget(me._id,#setIndentationWidth,p1)
end

-- setLexer (symbol)
on setLexer (me,p1)
	if voidP(p1) then $.Qt._qx.callWidget(me._id,#setLexer)
  else $.Qt._qx.callWidget(me._id,#setLexer,p1)
end

-- setMarginLineNumbers (int,bool)
on setMarginLineNumbers (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setMarginLineNumbers,p1,p2)
end

-- setMarginWidth (int,int|string)
on setMarginWidth (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setMarginWidth,p1,p2)
end

-- setMarginsBackgroundColor (color)
on setMarginsBackgroundColor (me,p1)
  $.Qt._qx.callWidget(me._id,#setMarginsBackgroundColor,p1)
end

-- setMarginsForegroundColor (color)
on setMarginsForegroundColor (me,p1)
  $.Qt._qx.callWidget(me._id,#setMarginsForegroundColor,p1)
end

-- setMarginsFont (FontID)
on setMarginsFont (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setMarginsFont,p1)
end

-- setModified (bool)
-- Sets the modified state of the text edit to m. Note that it is only possible
-- to clear the modified state (where m is false). Attempts to set the modified
-- state (where m is true) are ignored.
on setModified (me,p1)
  $.Qt._qx.callWidget(me._id,#setModified,p1)
end

-- setPaper (color)
on setPaper (me,p1)
  $.Qt._qx.callWidget(me._id,#setPaper,p1)
end

-- setProperty (string key, string value) // NEW
on setProperty (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setProperty,p1,p2)
end

-- setSelection (int,int,int,int)
on setSelection (me,p1,p2,p3,p4)
  $.Qt._qx.callWidget(me._id,#setSelection,p1,p2,p3,p4)
end

-- setSelectionBackgroundColor (color)
on setSelectionBackgroundColor (me,p1)
  $.Qt._qx.callWidget(me._id,#setSelectionBackgroundColor,p1)
end

-- setSelectionForegroundColor (color)
on setSelectionForegroundColor (me,p1)
  $.Qt._qx.callWidget(me._id,#setSelectionForegroundColor,p1)
end

-- setTabIndents (bool)
on setTabIndents (me,p1)
  $.Qt._qx.callWidget(me._id,#setTabIndents,p1)
end

-- setTabWidth (int)
on setTabWidth (me,p1)
  $.Qt._qx.callWidget(me._id,#setTabWidth,p1)
end

-- setText (string)
on setText (me,p1)
  $.Qt._qx.callWidget(me._id,#setText,p1)
end

-- setUtf8 (bool)
on setUtf8 (me,p1)
  $.Qt._qx.callWidget(me._id,#setUtf8,p1)
end

-- setWrapMode (int)
on setWrapMode (me,p1)
  $.Qt._qx.callWidget(me._id,#setWrapMode,p1)
end

-- tabWidth () -> int
on tabWidth (me)
  return $.Qt._qx.callWidget(me._id,#tabWidth)
end

-- text (*int line) -> string
on text (me,p1)
	if integerP(p1) then return $.Qt._qx.callWidget(me._id,#text,p1)
  return $.Qt._qx.callWidget(me._id,#text)
end

-- undo ()
on undo (me)
  $.Qt._qx.callWidget(me._id,#undo)
end

-- wordAtLineIndex (int line, int index) -> string word
on wordAtLineIndex (me,p1,p2)
  return $.Qt._qx.callWidget(me._id,#wordAtLineIndex,p1,p1)
end

-- wrapMode () -> int
on wrapMode (me)
  return $.Qt._qx.callWidget(me._id,#wrapMode)
end

-- zoomIn ()
on zoomIn (me)
  $.Qt._qx.callWidget(me._id,#zoomIn)
end

-- zoomOut ()
on zoomOut (me)
  $.Qt._qx.callWidget(me._id,#zoomOut)
end

-- zoomTo (int size)
on zoomTo (me,p1)
  $.Qt._qx.callWidget(me._id,#zoomTo,p1)
end



-- lexerPropertyNames () -> string
--on lexerPropertyNames (me)
--  return $.Qt._qx.callWidget(me._id,#lexerPropertyNames)
--end

-- lexerReadSettings (string iniFile) -> bool
on lexerReadSettings (me,p1)
  return $.Qt._qx.callWidget(me._id,#lexerReadSettings,p1)
end

-- lexerWriteSettings (string iniFile) -> bool
on lexerWriteSettings (me,p1)
  return $.Qt._qx.callWidget(me._id,#lexerWriteSettings,p1)
end

-- lexerSetColor (color, *int style)
on lexerSetColor (me,p1,p2)
	if integerP(p2) then $.Qt._qx.callWidget(me._id,#lexerSetColor,p1,p2)
	else $.Qt._qx.callWidget(me._id,#lexerSetColor,p1)
end

-- lexerSetPaper (color, *int style)
on lexerSetPaper (me,p1,p2)
	if integerP(p2) then $.Qt._qx.callWidget(me._id,#lexerSetPaper,p1,p2)
	else $.Qt._qx.callWidget(me._id,#lexerSetPaper,p1)
end

-- lexerSetDefaultColor (color)	
on lexerSetDefaultColor (me,p1)
	$.Qt._qx.callWidget(me._id,#lexerSetDefaultColor,p1)
end

-- lexerSetDefaultFont (int fontID)
on lexerSetDefaultFont (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
	$.Qt._qx.callWidget(me._id,#lexerSetDefaultFont,p1)
end

-- lexerSetDefaultPaper (color)
on lexerSetDefaultPaper (me,p1)
	$.Qt._qx.callWidget(me._id,#lexerSetDefaultPaper,p1)
end

-- MARKER

-- markerAdd (int line, int markerNumber) -> int mhandle
on markerAdd (me,p1,p2)
	return $.Qt._qx.callWidget(me._id,#markerAdd,p1,p2)
end

-- markerDefine (MarkerSymbol sym, *int markerNumber=-1) -> int markerNumber
on markerDefine (me,p1,p2)
	if voidP(p2) then return $.Qt._qx.callWidget(me._id,#markerDefine,p1)
	return $.Qt._qx.callWidget(me._id,#markerDefine,p1,p2)
end

-- markerDelete (int line, *int markerNumber=-1)
on markerDelete (me,p1,p2)
	if voidP(p2) then $.Qt._qx.callWidget(me._id,#markerDelete,p1)
	else $.Qt._qx.callWidget(me._id,#markerDelete,p1,p2)
end

-- markerDeleteAll (*int markerNumber=-1)
on markerDeleteAll (me,p1)
	if voidP(p1) then $.Qt._qx.callWidget(me._id,#markerDeleteAll)
	else $.Qt._qx.callWidget(me._id,#markerDeleteAll,p1)
end

-- markerDeleteHandle (int mhandle) 
on markerDeleteHandle (me,p1)
	$.Qt._qx.callWidget(me._id,#markerDeleteHandle,p1)
end

-- markerFindNext (int line, int mask) -> int line
on markerFindNext (me,p1,p2)
	return $.Qt._qx.callWidget(me._id,#markerFindNext,p1,p2)
end

-- markerFindPrevious (int line, int mask) -> int line
on markerFindPrevious (me,p1,p2)
	return $.Qt._qx.callWidget(me._id,#markerFindPrevious,p1,p2)
end

-- markersAtLine (int line) -> int mask
on markersAtLine (me,p1)
	return $.Qt._qx.callWidget(me._id,#markersAtLine,p1)
end

-- setMarkerBackgroundColor (color, int markerNumber=-1, int alpha=255)
on setMarkerBackgroundColor (me,p1,p2,p3)
	if voidP(p2) then $.Qt._qx.callWidget(me._id,#setMarkerBackgroundColor,p1)
	else if voidP(p3) then $.Qt._qx.callWidget(me._id,#setMarkerBackgroundColor,p1,p2)
	else $.Qt._qx.callWidget(me._id,#setMarkerBackgroundColor,p1,p2,p3)
end

-- setMarkerForegroundColor (color, int markerNumber=-1, int alpha=255)
on setMarkerForegroundColor (me,p1,p2,p3)
	if voidP(p2) then $.Qt._qx.callWidget(me._id,#setMarkerForegroundColor,p1)
	else if voidP(p3) then $.Qt._qx.callWidget(me._id,#setMarkerForegroundColor,p1,p2)
	else $.Qt._qx.callWidget(me._id,#setMarkerForegroundColor,p1,p2,p3)
end

-- markerLine (int mhandle) -> int line
on markerLine (me,p1)
	return $.Qt._qx.callWidget(me._id,#markerLine,p1)
end

-- setMarginMarkerMask (int margin, int mask)
on setMarginMarkerMask (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#setMarginMarkerMask,p1,p2)
end

-- setMarginSensitivity (int margin, bool flag)
on setMarginSensitivity (me,p1,p2)
	$.Qt._qx.callWidget(me._id,#setMarginSensitivity,p1,p2)
end

-- HOTSPOTS

-- setHotspotBackgroundColor (color)
on setHotspotBackgroundColor (me,p1)
	$.Qt._qx.callWidget(me._id,#setHotspotBackgroundColor,p1)
end

-- setHotspotForegroundColor (color)
on setHotspotForegroundColor (me,p1)
	$.Qt._qx.callWidget(me._id,#setHotspotForegroundColor,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- apiPreparationFinished
on apiPreparationFinished(me,id)
  me._detach(#apiPreparationFinished,me)
end

-- copyAvailable -> bool
on copyAvailable(me,id,p1)
  me._detach(#copyAvailable,me,p1)
end

-- cursorPositionChanged -> int,int
on cursorPositionChanged(me,id,p1,p2)
  me._detach(#cursorPositionChanged,me,p1,p2)
end

-- doubleClicked -> int position, int line  (, int modifiers)
on doubleClicked(me,id,p1,p2)
  me._detach(#doubleClicked,me,p1,p2)
end

-- hotspotClicked -> int position, int modifiers
on hotspotClicked(me,id,p1,p2)
  me._detach(#hotspotClicked,me,p1,p2)
end

-- hotspotDoubleClicked -> int position, int modifiers
on hotspotDoubleClicked(me,id,p1,p2)
  me._detach(#hotspotDoubleClicked,me,p1,p2)
end

-- hotspotReleaseClicked -> int position, int modifiers
on hotspotReleaseClicked(me,id,p1,p2)
  me._detach(#hotspotReleaseClicked,me,p1,p2)
end

-- marginClicked -> int margin, int line  (, int state)
on marginClicked(me,id,p1,p2)
  me._detach(#marginClicked,me,p1,p2)
end

-- modificationChanged -> bool
on modificationChanged(me,id,p1)
  me._detach(#modificationChanged,me,p1)
end

-- selectionChanged
on selectionChanged(me,id)
  me._detach(#selectionChanged,me)
end

-- textChanged
on textChanged(me,id)
  me._detach(#textChanged,me)
end
