--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #TimeEdit
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #TimeEdit
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- displayFormat () -> string
on displayFormat (me)
  return $.Qt._qx.callWidget(me._id,#displayFormat)
end

-- setDisplayFormat (string)
on setDisplayFormat (me,p1)
  $.Qt._qx.callWidget(me._id,#setDisplayFormat,p1)
end

-- SetMaximumTime (int,int,int)
on SetMaximumTime (me,p1,p2,p3)
  $.Qt._qx.callWidget(me._id,#SetMaximumTime,p1,p2,p3)
end

-- SetMinimumTime (int,int,int)
on SetMinimumTime (me,p1,p2,p3)
  $.Qt._qx.callWidget(me._id,#SetMinimumTime,p1,p2,p3)
end

-- setTime (int,int,int)
on setTime (me,p1,p2,p3)
  $.Qt._qx.callWidget(me._id,#setTime,p1,p2,p3)
end

-- time ()
on time (me)
  $.Qt._qx.callWidget(me._id,#time)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- dateTimeChanged -> string
on dateTimeChanged(me,id,p1)
  me._detach(#dateTimeChanged,me,p1)
end
