--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID,string)
on new (me,p1,p2)
  me._class = #ToolBar
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1,p2)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #ToolBar
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- addAction (ActionID)
on addAction (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#addAction,p1)
end

-- addSeparator ()
on addSeparator (me)
  $.Qt._qx.callWidget(me._id,#addSeparator)
end

-- addWidget (WidgetID) -> ActionID
on addWidget (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  obj = $.Qt.Action._make($.Qt._qx.callWidget(me._id,#addWidget,p1))
  me._children.add(obj)
  return obj
end

-- setAllowedAreas (int)
on setAllowedAreas (me,p1)
  $.Qt._qx.callWidget(me._id,#setAllowedAreas,p1)
end

-- setFloatable (bool)
on setFloatable (me,p1)
  $.Qt._qx.callWidget(me._id,#setFloatable,p1)
end

-- setIconSize (int,int)
on setIconSize (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setIconSize,p1,p2)
end

-- setMovable (bool)
on setMovable (me,p1)
  $.Qt._qx.callWidget(me._id,#setMovable,p1)
end

-- setToolButtonStyle (int)
on setToolButtonStyle (me,p1)
  $.Qt._qx.callWidget(me._id,#setToolButtonStyle,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- visibilityChanged -> bool
on visibilityChanged (me,id,p1)
  me._detach(#visibilityChanged,me,p1)
end
