--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
-- new (*WidgetID)
on new (me,p1)
  me._class = #WebView
  me.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
  if ilk(p1)=#instance then
    p1._children.add(me)
    p1 = p1._id
  end if
  me._id = $.Qt._qx.newWidget(me._class,p1)
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iWidget.ls").new()
	obj._class = #WebView
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- back ()
on back (me)
  $.Qt._qx.callWidget(me._id,#back)
end

-- findText (string,*int) -> bool
on findText (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#findText,p1,p2)
end

-- forward ()
on forward (me)
  $.Qt._qx.callWidget(me._id,#forward)
end

-- history () -> list
on history (me)
  return $.Qt._qx.callWidget(me._id,#history)
end

-- icon () -> image
on icon (me)
  return $.Qt._qx.callWidget(me._id,#icon)
end

-- load (string url)
on load (me,p1)
  $.Qt._qx.callWidget(me._id,#load,p1)
end

-- page () -> WebPageID
on page (me)
  obj = $.Qt.WebPage._make($.Qt._qx.callWidget(me._id,#page))
  me._children.add(obj)
  return obj
end

-- print (int)
on print (me,p1)
  $.Qt._qx.callWidget(me._id,#print,p1)
end

-- reload ()
on reload (me)
  $.Qt._qx.callWidget(me._id,#reload)
end

-- renderHints ()
on renderHints (me)
  $.Qt._qx.callWidget(me._id,#renderHints)
end

-- selectedText () -> string
on selectedText (me)
  return $.Qt._qx.callWidget(me._id,#selectedText)
end

-- setContent (string,*string,string)
on setContent (me,p1,p2,p3)
  $.Qt._qx.callWidget(me._id,#setContent,p1,p2,p3)
end

-- setHtml (string,*string)
on setHtml (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setHtml,p1,p2)
end

-- setPage (WebPageID)
on setPage (me,p1)
  if ilk(p1)=#instance then p1 = p1._id
  $.Qt._qx.callWidget(me._id,#setPage,p1)
end

-- setRenderHints (int)
on setRenderHints (me,p1)
  $.Qt._qx.callWidget(me._id,#setRenderHints,p1)
end

-- setSetting (int,bool)
on setSetting (me,p1,p2)
  $.Qt._qx.callWidget(me._id,#setSetting,p1,p2)
end

-- setTextSizeMultiplier (float)
on setTextSizeMultiplier (me,p1)
  $.Qt._qx.callWidget(me._id,#setTextSizeMultiplier,p1)
end

-- setUrl (string)
on setUrl (me,p1)
  $.Qt._qx.callWidget(me._id,#setUrl,p1)
end

-- setZoomFactor (float)
on setZoomFactor (me,p1)
  $.Qt._qx.callWidget(me._id,#setZoomFactor,p1)
end

-- stop ()
on stop (me)
  $.Qt._qx.callWidget(me._id,#stop)
end

-- textSizeMultiplier () -> float
on textSizeMultiplier (me)
  return $.Qt._qx.callWidget(me._id,#textSizeMultiplier)
end

-- title () -> string
on title (me)
  return $.Qt._qx.callWidget(me._id,#title)
end

-- triggerPageAction (int)
on triggerPageAction (me,p1)
  $.Qt._qx.callWidget(me._id,#triggerPageAction,p1)
end

-- url () -> string
on url (me)
  return $.Qt._qx.callWidget(me._id,#url)
end

-- zoomFactor () -> float
on zoomFactor (me)
  return $.Qt._qx.callWidget(me._id,#zoomFactor)
end

----------------------------------------
-- STATIC
----------------------------------------

-- iconForUrl (string url) -> image
on iconForUrl (scr,p1)
  return $.Qt._qx.callWidget(#WebView,#iconForUrl,p1)
end

-- setGlobalSetting (int,bool)
on setGlobalSetting (scr,p1,p2)
  $.Qt._qx.callWidget(#WebView,#setGlobalSetting,p1,p2)
end

-- setIconDatabasePath (string)
on setIconDatabasePath (scr,p1)
  $.Qt._qx.callWidget(#WebView,#setIconDatabasePath,p1)
end

----------------------------------------
-- SIGNALS
----------------------------------------

-- iconChanged
on iconChanged(me,id)
  me._detach(#iconChanged,me)
end

-- keyPressEvent
on keyPressEvent(me,id)
  me._detach(#keyPressEvent,me)
end

-- keyReleaseEvent
on keyReleaseEvent(me,id)
  me._detach(#keyReleaseEvent,me)
end

-- linkClicked -> string
on linkClicked(me,id,p1)
  me._detach(#linkClicked,me,p1)
end

-- loadFinished -> bool
on loadFinished(me,id,p1)
  me._detach(#loadFinished,me,p1)
end

-- loadProgress -> int
on loadProgress(me,id,p1)
  me._detach(#loadProgress,me,p1)
end

-- loadStarted
on loadStarted(me,id)
  me._detach(#loadStarted,me)
end

-- mouseDoubleClickEvent
on mouseDoubleClickEvent(me,id)
  me._detach(#mouseDoubleClickEvent,me)
end

-- mouseMoveEvent
on mouseMoveEvent(me,id)
  me._detach(#mouseMoveEvent,me)
end

-- mousePressEvent
on mousePressEvent(me,id)
  me._detach(#mousePressEvent,me)
end

-- mouseReleaseEvent
on mouseReleaseEvent(me,id)
  me._detach(#mouseReleaseEvent,me)
end

-- selectionChanged
on selectionChanged(me,id)
  me._detach(#selectionChanged,me)
end

-- statusBarMessage -> string
on statusBarMessage(me,id,p1)
  me._detach(#statusBarMessage,me,p1)
end

-- titleChanged -> string
on titleChanged(me,id,p1)
  me._detach(#titleChanged,me,p1)
end

-- urlChanged -> string
on urlChanged(me,id,p1)
  me._detach(#urlChanged,me,p1)
end

-- wheelEvent
on wheelEvent(me,id)
  me._detach(#wheelEvent,me)
end
